Difference between revisions of "Mesh to Part"

From FreeCAD Documentation
Jump to navigation Jump to search
(Marked this version for translation)
 
(22 intermediate revisions by 4 users not shown)
Line 4: Line 4:
 
<!--T:11-->
 
<!--T:11-->
 
{{Docnav
 
{{Docnav
|[[Topological_data_scripting|Topological data scripting]]
+
|[[Mesh_Scripting|Mesh Scripting]]
|[[Scenegraph]]
+
|[[Scenegraph|Scenegraph]]
 
}}
 
}}
  
Line 12: Line 12:
 
<translate>
 
<translate>
  
==Converting Part objects to meshes== <!--T:1-->
+
==Convert Part objects to meshes== <!--T:1-->
  
 
<!--T:2-->
 
<!--T:2-->
Converting higher-level objects such as [[Part Module|Part]] shapes to simpler objects such as [[Mesh Module|meshes]] is a pretty simple operation where all faces of a Part object get triangulated. The result of that triangulation (tessellation) is then used to construct a mesh:
+
Converting higher-level objects such as [[Part Module|Part]] shapes to simpler objects such as [[Mesh Module|meshes]] is a pretty straightforward operation where all faces of a Part object get triangulated. The result of that triangulation (tessellation) is then used to construct a mesh:
 
 
''The following code assumes our document contains one Part object.''
 
  
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
# let's assume our document contains one Part object
 
 
import Mesh
 
import Mesh
 +
 +
obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
 +
shp = obj.Shape
 
faces = []
 
faces = []
shape = FreeCAD.ActiveDocument.ActiveObject.Shape
+
 
triangles = shape.tessellate(1) # the number represents the precision of the tessellation
+
triangles = shp.tessellate(1) # the number represents the precision of the tessellation
 
for tri in triangles[1]:
 
for tri in triangles[1]:
 
     face = []
 
     face = []
Line 37: Line 37:
 
<translate>
 
<translate>
  
<!--T:3-->
+
<!--T:17-->
Sometimes the triangulation of certain faces offered by OpenCascade is quite ugly. If the face has a rectangular parameter space and doesn't contain any holes or other trimming curves you can also create a mesh manually:
+
Alternative example:
  
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
 
import Mesh
 
import Mesh
def makeMeshFromFace(u, v, face):
+
import MeshPart
    (a, b, c, d) = face.ParameterRange
 
    pts = []
 
    for j in range(v):
 
        for i in range(u):
 
            s = 1.0 / (u - 1) * (i * b + (u - 1 - i) * a)
 
            t = 1.0 / (v - 1) * (j * d + (v - 1 - j) * c)
 
            pts.append(face.valueAt(s, t))
 
  
    mesh=Mesh.Mesh()
+
obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
    for j in range(v - 1):
+
shp = obj.Shape
        for i in range(u - 1):
 
            mesh.addFacet(pts[u * j + i], pts[u * j + i + 1], pts[u * (j + 1) + i])
 
            mesh.addFacet(pts[u * (j + 1) + i], pts[u*j+i+1], pts[u * (j + 1) + i + 1])
 
  
    return mesh
+
mesh = FreeCAD.ActiveDocument.addObject("Mesh::Feature", "Mesh")
 +
mesh.Mesh = MeshPart.meshFromShape(
 +
        Shape=shp,
 +
        LinearDeflection=0.01,
 +
        AngularDeflection=0.025,
 +
        Relative=False)
 
}}
 
}}
 
<translate>
 
<translate>
  
==Converting Meshes to Part objects== <!--T:4-->
+
==Convert meshes to Part objects== <!--T:4-->
  
 
<!--T:5-->
 
<!--T:5-->
Converting Meshes to Part objects is an extremely important operation in CAD work, because very often you receive 3D data in mesh format from other people or outputted from other applications. Meshes are very practical to represent free-form geometry and big visual scenes, as it is very lightweight, but for CAD we generally prefer higher-level objects that carry much more information, such as the idea of solid, or faces made of curves instead of triangles.
+
Converting meshes to Part objects is a common operation. Very often you will receive 3D data in a mesh format. Meshes are quite practical for representing free-form geometry and big visual scenes, as they are very lightweight. But in FreeCAD we generally prefer higher-level objects, solids, that can carry much more information and allow for curved faces.
  
 
<!--T:6-->
 
<!--T:6-->
Converting meshes to those higher-level objects (handled by the [[Part Module]] in FreeCAD) is not an easy operation. Meshes can be made of thousands of triangles (for example when generated by a 3D scanner), and having solids made of the same number of faces would be extremely heavy to manipulate. So you generally want to optimize the object when converting.
+
Converting meshes to those higher-level objects (handled by the [[Part Module]] in FreeCAD) is not an easy operation. Meshes can contain thousands of triangles (for example when generated by a 3D scanner), and solids made of the same number of faces would be extremely difficult to manipulate. So you generally want to optimize the object when converting.
  
 
<!--T:7-->
 
<!--T:7-->
FreeCAD currently offers two methods to convert Meshes to Part objects. The first method is a simple, direct conversion, without any optimization:
+
FreeCAD currently offers two methods to convert meshes to Part objects. The first method is a simple, direct conversion without any optimization:
  
 
</translate>
 
</translate>
Line 80: Line 75:
 
mesh = Mesh.createTorus()
 
mesh = Mesh.createTorus()
 
shape = Part.Shape()
 
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Topology,0.05) # the second arg is the tolerance for sewing
+
shape.makeShapeFromMesh(mesh.Topology, 0.05) # the second arg is the tolerance for sewing
 
solid = Part.makeSolid(shape)
 
solid = Part.makeSolid(shape)
 
Part.show(solid)
 
Part.show(solid)
Line 87: Line 82:
  
 
<!--T:8-->
 
<!--T:8-->
The second method offers the possibility to consider mesh facets coplanar when the angle between them is under a certain value. This allows to build much simpler shapes: (let's assume our document contains one Mesh object)
+
The second method offers the possibility to consider mesh facets co-planar when the angle between them is under a certain value, reducing the number of faces in the final result:
  
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
# let's assume our document contains one Mesh object
 
 
import Mesh
 
import Mesh
 
import Part
 
import Part
 
import MeshPart
 
import MeshPart
  
 +
obj = FreeCADGui.Selection.getSelection()[0] # a Mesh object must be preselected
 +
mesh = obj.Mesh
 +
segments = mesh.getPlanarSegments(0.00001) # use rather strict tolerance here
 
faces = []
 
faces = []
mesh = App.ActiveDocument.ActiveObject.Mesh
+
 
segments = mesh.getPlanes(0.00001) # use rather strict tolerance here
 
 
 
for i in segments:
 
for i in segments:
  if len(i) > 0:
+
    if len(i) > 0:
    # a segment can have inner holes
+
        # a segment can have inner holes
    wires = MeshPart.wireFromSegment(mesh, i)
+
        wires = MeshPart.wireFromSegment(mesh, i)
    # we assume that the exterior boundary is that one with the biggest bounding box
+
        # we assume that the exterior boundary is that one with the biggest bounding box
    if len(wires) > 0:
+
        if len(wires) > 0:
        ext = None
+
            ext = None
        max_length=0
+
            max_length=0
        for i in wires:
+
            for i in wires:
          if i.BoundBox.DiagonalLength > max_length:
+
                if i.BoundBox.DiagonalLength > max_length:
              max_length = i.BoundBox.DiagonalLength
+
                    max_length = i.BoundBox.DiagonalLength
              ext = i
+
                    ext = i
  
        wires.remove(ext)
+
            wires.remove(ext)
        # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
+
            # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
        for i in wires:
+
            for i in wires:
          i.reverse()
+
                i.reverse()
  
        # make sure that the exterior wires comes as first in the list
+
            # make sure that the exterior wires comes as first in the list
        wires.insert(0, ext)
+
            wires.insert(0, ext)
        faces.append(Part.Face(wires))
+
            faces.append(Part.Face(wires))
  
shell = Part.Compound(faces)
+
solid = Part.Solid(Part.Shell(faces))
Part.show(shell)
+
Part.show(solid)
# solid = Part.Solid(Part.Shell(faces))
 
# Part.show(solid)
 
 
}}
 
}}
 
<translate>
 
<translate>
Line 131: Line 124:
 
<!--T:9-->
 
<!--T:9-->
 
{{Docnav
 
{{Docnav
|[[Topological_data_scripting|Topological data scripting]]
+
|[[Mesh_Scripting|Mesh Scripting]]
|[[Scenegraph]]
+
|[[Scenegraph|Scenegraph]]
 
}}
 
}}
  
 
</translate>
 
</translate>
 
{{Powerdocnavi{{#translation:}}}}
 
{{Powerdocnavi{{#translation:}}}}
 +
[[Category:Developer Documentation{{#translation:}}]]
 
[[Category:Python Code{{#translation:}}]]
 
[[Category:Python Code{{#translation:}}]]
 +
{{Mesh Tools navi{{#translation:}}}}
 +
{{clear}}

Latest revision as of 19:25, 8 June 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎svenska • ‎čeština • ‎русский • ‎日本語
Arrow-left.svg Previous: Mesh Scripting
Next: Scenegraph Arrow-right.svg

Convert Part objects to meshes

Converting higher-level objects such as Part shapes to simpler objects such as meshes is a pretty straightforward operation where all faces of a Part object get triangulated. The result of that triangulation (tessellation) is then used to construct a mesh:

import Mesh

obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
shp = obj.Shape
faces = []

triangles = shp.tessellate(1) # the number represents the precision of the tessellation
for tri in triangles[1]:
    face = []
    for i in tri:
        face.append(triangles[0][i])
    faces.append(face)

m = Mesh.Mesh(faces)
Mesh.show(m)

Alternative example:

import Mesh
import MeshPart

obj = FreeCADGui.Selection.getSelection()[0] # a Part object must be preselected
shp = obj.Shape

mesh = FreeCAD.ActiveDocument.addObject("Mesh::Feature", "Mesh")
mesh.Mesh = MeshPart.meshFromShape(
        Shape=shp,
        LinearDeflection=0.01,
        AngularDeflection=0.025,
        Relative=False)

Convert meshes to Part objects

Converting meshes to Part objects is a common operation. Very often you will receive 3D data in a mesh format. Meshes are quite practical for representing free-form geometry and big visual scenes, as they are very lightweight. But in FreeCAD we generally prefer higher-level objects, solids, that can carry much more information and allow for curved faces.

Converting meshes to those higher-level objects (handled by the Part Module in FreeCAD) is not an easy operation. Meshes can contain thousands of triangles (for example when generated by a 3D scanner), and solids made of the same number of faces would be extremely difficult to manipulate. So you generally want to optimize the object when converting.

FreeCAD currently offers two methods to convert meshes to Part objects. The first method is a simple, direct conversion without any optimization:

import Mesh
import Part

mesh = Mesh.createTorus()
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Topology, 0.05) # the second arg is the tolerance for sewing
solid = Part.makeSolid(shape)
Part.show(solid)

The second method offers the possibility to consider mesh facets co-planar when the angle between them is under a certain value, reducing the number of faces in the final result:

import Mesh
import Part
import MeshPart

obj = FreeCADGui.Selection.getSelection()[0] # a Mesh object must be preselected
mesh = obj.Mesh
segments = mesh.getPlanarSegments(0.00001) # use rather strict tolerance here
faces = []

for i in segments:
    if len(i) > 0:
        # a segment can have inner holes
        wires = MeshPart.wireFromSegment(mesh, i)
        # we assume that the exterior boundary is that one with the biggest bounding box
        if len(wires) > 0:
            ext = None
            max_length=0
            for i in wires:
                if i.BoundBox.DiagonalLength > max_length:
                    max_length = i.BoundBox.DiagonalLength
                    ext = i

            wires.remove(ext)
            # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
            for i in wires:
                i.reverse()

            # make sure that the exterior wires comes as first in the list
            wires.insert(0, ext)
            faces.append(Part.Face(wires))

solid = Part.Solid(Part.Shell(faces))
Part.show(solid)
Arrow-left.svg Previous: Mesh Scripting
Next: Scenegraph Arrow-right.svg